var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import { onMounted, unref, onDeactivated, onBeforeUnmount, watch } from "vue";
const useEventListener = (event, listener, options = {}) => {
  const _a = options, { target = window } = _a, rest = __objRest(_a, ["target"]);
  const remove = (el) => {
    const _el = unref(el);
    _el && _el.removeEventListener(event, listener, rest);
  };
  const add = (el) => {
    const _el = unref(el);
    _el && _el.addEventListener(event, listener, rest);
  };
  watch(() => unref(target), (el, prevEl) => {
    remove(prevEl);
    add(el);
  });
  onMounted(() => add(target));
  onDeactivated(() => remove(target));
  onBeforeUnmount(() => remove(target));
};
export {
  useEventListener
};
