import { onMounted, onBeforeUnmount, onDeactivated, watch } from "vue";
import { useState } from "../use-state";
const useTitle = (initialTitle = "") => {
  const [title, setTitle] = useState(initialTitle);
  const titleChange = (title2 = "") => setTitle(title2);
  const setDocumentTitle = () => document.title = title.value;
  const resetDocumentTitle = () => document.title = "";
  onMounted(setDocumentTitle);
  watch(title, setDocumentTitle);
  onBeforeUnmount(resetDocumentTitle);
  onDeactivated(resetDocumentTitle);
  return {
    titleChange,
    title
  };
};
export {
  useTitle
};
